"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var PayloadGenerator_1 = require("./PayloadGenerator");
var readline = __importStar(require("readline"));
var Requester_1 = require("./Requester");
var yargs = __importStar(require("yargs"));
var HTTPParser_1 = require("./HTTPParser");
var fs = __importStar(require("fs"));
var Handler = /** @class */ (function () {
    function Handler() {
        this.fuzzStats = { done: 0, found: 0 };
        this.fuzzResultsString = "[+] Fuzz - Requests Done/Success Results: ";
    }
    Handler.prototype.doRequest = function (opts, xmlPayload) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        Requester_1.Requester.fromString(opts.requestFile, xmlPayload, opts.fuzzLine).then(function (_a) {
                            var r = _a[0], line = _a[1];
                            var resp = HTTPParser_1.HTTPParser.axiosResponseToString(r);
                            _this.processRequestResponse(opts, resp, line);
                            resolve();
                        }).catch(function (err) {
                            console.error("Error on request for " + err[1] + " - " + (err[0].errno || err[0]));
                            reject();
                        });
                    })];
            });
        });
    };
    Handler.prototype.processRequestResponse = function (opts, resp, line) {
        //check if needs to output response
        //if errorstring or success string are not provided print everything
        //other wise only print if expected success pattern occurs
        var output = true;
        if (opts.erroString && resp.includes(opts.erroString))
            output = false;
        if (opts.successString) {
            if (resp.includes(opts.successString))
                output = true;
            else
                output = false;
        }
        //if we need to output the response it may to console or to file
        if (output) {
            if (opts.fuzz) {
                var o = "Response for " + line + "\n\n" + resp + "\n\n---------------------------------------------------------------\n";
                if (opts.requestOutput) //output fuzz to file
                    fs.appendFileSync(opts.requestOutput, o);
                else //output fuzz to console
                    console.log(o);
            }
            else { //output single request
                if (opts.requestOutput)
                    fs.writeFileSync(opts.requestOutput, resp);
                else {
                    console.log("Response: ");
                    console.log("");
                    console.log(resp);
                }
            }
        }
        this.fuzzStats.done++;
        if (output)
            this.fuzzStats.found++;
        if (process.env.NODE_ENV !== "test")
            this.updateFuzzedValues();
    };
    Handler.prototype.doWork = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var xmlPayload;
                        //generate payload
                        if (opts.xxeIterations)
                            xmlPayload = PayloadGenerator_1.PayloadGenerator.xee(opts.xxeIterations, opts.template);
                        else {
                            var generator = new PayloadGenerator_1.PayloadGenerator(opts.address, opts.port);
                            xmlPayload = generator.generate(opts.type, opts.mode, opts.encoding, opts.commandarg, opts.template);
                        }
                        //if doing a request do not output xml
                        if (opts.requestFile) { //do the request
                            _this.doRequest(opts, xmlPayload).then(function () { resolve(); });
                        }
                        else if (opts.output) { //output xml
                            fs.writeFile(opts.output, xmlPayload, function () {
                                console.log("XML Payload written to " + opts.output);
                                resolve();
                            });
                        }
                        else {
                            console.log(xmlPayload);
                            resolve();
                        }
                    })];
            });
        });
    };
    Handler.prototype.fuzz = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.fuzzStats = { done: 0, found: 0 };
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var proms = [];
                        //wordlist is needed for fuzz. may need to change this when adding portscan
                        if (!opts.wordlist) {
                            yargs.showHelp();
                            process.exit();
                        }
                        //check if checklist exists
                        if (!fs.existsSync(opts.wordlist)) {
                            console.error("Wordlist file not found");
                            process.exit();
                        }
                        //create a file to be appended with results
                        if (opts.requestOutput) {
                            if (fs.existsSync(opts.requestOutput))
                                fs.unlinkSync(opts.requestOutput);
                            fs.writeFileSync(opts.requestOutput, "");
                        }
                        process.stdout.write(_this.fuzzResultsString);
                        //read wordlist a line at a time
                        var rd = readline.createInterface({ input: fs.createReadStream(opts.wordlist) });
                        rd.on('line', function (line) {
                            opts.fuzzLine = line;
                            opts.commandarg = opts.originalCommandarg.replace("{{FUZZ}}", line);
                            proms.push(_this.doWork(opts));
                        });
                        //check for all promises only when finished reading file
                        rd.on('close', function () {
                            Promise.all(proms).then(function () { resolve(); console.log("\n[+] All Done"); });
                        });
                    })];
            });
        });
    };
    Handler.prototype.updateFuzzedValues = function () {
        process.stdout.cursorTo(this.fuzzResultsString.length);
        process.stdout.clearLine(1);
        process.stdout.cursorTo(this.fuzzResultsString.length);
        process.stdout.write(this.fuzzStats.done + "/" + this.fuzzStats.found);
    };
    return Handler;
}());
exports.Handler = Handler;
